%----------------------------------------------------
%
%       SPA_CORC.M
%
% Computes the autocorrelation matrix using forward
% and backward snapshots from signal x and order nq
% for the matrix.
%
%   Requires:
%
% From the main program -The vector of data signal x
%                       - The order nq of the matrix
%   Provides:
%
%   ra(nq,nq) the correlation matrix estimate order nq
%
%   Miguel Angel Lagunas              Feb 1995
%------------------------------------------------------
function ra=spa_corc(x,nq);
n=length(x);
l1=1;l2=nq;xf=[];xb=[];luso=0;
while l2<=n;
  auso=x(l1:l2);
  xf=[xf;auso];xb=[xb;fliplr(auso)];
  l1=l1+1;l2=l2+1;luso=luso+1;
end;
ra=0.5*(xf'*xf+xb'*xb)/luso;
%%ra=xf'*xf/luso;
%------------------------------------------------------