%-----------------------------------------------------------------------
%
%                  spa_kika.m
%
%   Miguel A. Lagunas                         July 2007
%
%-----------------------------------------------------------------------
function [sigma,outn,outd]=spa_kika(xinf,hmod,stip,nq,np);
nq1=nq-1;np1=np-1;nsam=length(xinf);nres=length(hmod);
% Number of samples per record for denominator
nsam4=max([nq1 np1 nsam/4]);
nns=2;
while nns<nsam4;
   nns=2*nns;
end;
stp=['Periodogram for constrains'];
% Routine SPA_WOS_CEPS
xb=spa_wos_ceps(xinf,nns,nns,stp);
% Compute cepstrum
cuso=ifft(log(xb));
% Choose length
mm1=30;
% Compute in cep(.) the coefficients of cepstrum deriv.
cep=(1:1:mm1-1).*cuso(2:mm1);clear cuso;
% Compute impulse response
i=2;h(1)=1;
while i<mm1+0.5;
   h(i)=0;
   for k=1:i-1;
       h(i)=h(i)+h(k)*cep(i-k);
   end;
   h(i)=h(i)/(i-1);
   i=i+1;
end;
% Write the system matrix
hh=zeros(mm1,nq);
for i=1:mm1;
    for k=1:nq;
        if k<=i;
            hh(i,k)=h(i-k+1);
        end;
    end;
end;
cuso=hh(nq+1:mm1,2:nq);duso=hh(nq+1:mm1,1);
outd=-(inv(cuso'*cuso))*(cuso'*duso);
outn=hh(2:nq,1)+hh(2:nq,2:nq)*outd;
outd=[1;outd];outn=[1;outn];sigma=1;
sigma2=sigma^2;
disp('Noise power');disp(sigma2);
disp('Numerator coefficients');disp(outn);
disp('Coefficients denorminator');disp(outd);
% Compute spectral estimate with resolution nres
aus=20*log10(abs((fft(outn,2*nres)./fft(outd,2*nres))));
%%aus=aus+(10*log10(sigma2))*ones(1,length(aus));
% Plot estimate together with actual spectrum hmod
figure(3);clf;
plot((1:1:nres),aus(1:nres),'r');grid;xlabel('frequency');
ylabel('dB');title(['KiKa-ARMA Estimate (red) actual(blue)' stip] );
hold on;plot((1:1:nres),hmod,'b');hold off;
